{
type color = Red | Green | Blue | Cyan | Magenta | Yellow | Black | White ;;
type sml_tag = Color of color | Size of int | Bold | Emphasis | Italic | Plain | Strong | Typewritter | Underline1 | Underline2 | Underline3 | Underline;;

let tags = ref [];;
exception EOF;;
}

rule sml_lexed_node = parse
	| "<B>" 	{ tags := Bold::!tags; sml_lexed_node lexbuf }
	| "<EM>"	{ tags := Emphasis::!tags; sml_lexed_node lexbuf }
	| "<I>"		{ tags := Italic::!tags; sml_lexed_node lexbuf }
	| "<PL>"	{ tags := Plain::!tags; sml_lexed_node lexbuf }
	| "<S>"		{ tags := Strong::!tags; sml_lexed_node lexbuf }
	| "<TT>"	{ tags := Typewritter::!tags; sml_lexed_node lexbuf }
	| "<U>"		{ tags := Underline::!tags; sml_lexed_node lexbuf }
	| "<r>"		{ tags := Color(Red)::!tags; sml_lexed_node lexbuf }
	| "<g>"		{ tags := Color(Green)::!tags; sml_lexed_node lexbuf }
	| "<b>"		{ tags := Color(Blue)::!tags; sml_lexed_node lexbuf }
	| "<c>"		{ tags := Color(Cyan)::!tags; sml_lexed_node lexbuf }
	| "<m>"		{ tags := Color(Magenta)::!tags; sml_lexed_node lexbuf }
	| "<y>"		{ tags := Color(Yellow)::!tags; sml_lexed_node lexbuf }
	| "<k>"		{ tags := Color(Black)::!tags; sml_lexed_node lexbuf }
	| "<w>"		{ tags := Color(White)::!tags; sml_lexed_node lexbuf }
	| "<0>"		{ tags := Size(0)::!tags; sml_lexed_node lexbuf }
	| "<1>"		{ tags := Size(1)::!tags; sml_lexed_node lexbuf }
	| "<2>"		{ tags := Size(2)::!tags; sml_lexed_node lexbuf }
	| "<3>"		{ tags := Size(3)::!tags; sml_lexed_node lexbuf }
	| "<4>"		{ tags := Size(4)::!tags; sml_lexed_node lexbuf }
	| "<5>"		{ tags := Size(5)::!tags; sml_lexed_node lexbuf }
	| "<6>"		{ tags := Size(6)::!tags; sml_lexed_node lexbuf }
	| "<7>"		{ tags := Size(7)::!tags; sml_lexed_node lexbuf }
	| "<8>"		{ tags := Size(8)::!tags; sml_lexed_node lexbuf }
	| "<9>"		{ tags := Size(9)::!tags; sml_lexed_node lexbuf }
	| "</"['a'-'z' 'A'-'Z' '0'-'9']+">" { tags := (List.tl !tags) ; sml_lexed_node lexbuf }
	| _ { (Lexing.lexeme_char lexbuf 0), !tags }
	| eof { raise EOF }


